#ifndef PARTICLE_H
#define PARTICLE_H

#include "Color.h"
#include "Texture.h"
#include "Vec2D.h"

// stan czsteczki
class ParticleState
{
public:
	Color color;
	float angle;
	float size;
};

// czsteczka
class Particle
{
public:
	// pozycja
	Vec2D position;

	// prdko
	Vec2D velocity;

	// aktualne parametry czsteczki
	ParticleState current;

	// docelowe parametry czsteczki / zmiana
	ParticleState change;

	// czas w jakim czsteczka ma si zamieni 
	float changeDuration;

	// zamiana docelowych parametrw na to o ile maj si zmienia
	void CalculateChangePerSecond()
	{
		change.color = (change.color - current.color) / changeDuration;
		change.angle = (change.angle - current.angle) / changeDuration;
		change.size  = (change.size - current.size) / changeDuration;
	}

	const UVRegion* uvRegion;
private:
	friend class ParticleSystem;

	Particle* nextParticle;
	Particle* prevParticle;
};

#endif